<?
	// шифр многоалфавитной подстановки
	// автор: oruchimaru00001@yandex.ru
	
	class crypt{
		
		private static $instance;
		
		public $chars = '|abcdefghigklmnopqrstuvwxyz0123456789.ABCDEFGHIGKLMNOPQRSTUVWXYZ ';
		public $separator = '_';
		public $code_chars = 8;
		
		public static function getInstance(){
			if (self::$instance === null) {
				self::$instance = new self;
			}
			return self::$instance;
		}
		
		public function __construct(){
			return true;
		}
		
		// создание короткой строки символов
		public function createChars($data){
			$ar_chars = str_split($data);
			foreach($ar_chars as $char){
				$ar_chars_temp[$char] = $char;
			}
			$this->chars = implode('', $ar_chars_temp);
			return $this->chars;
		}
		
		// Создание ключа для шифрования
		public function getKey(){
			// последовательность симвовлов
			$chars = $this->chars;
			//колличество символов в коде
			$code_chars = $this->code_chars;
			// разделитель
			$separator = $this->separator;
			// массив ключа шифра
			$ar_key = array();
			$n = 0;
			while($n < strlen($chars)){
				// гененирруем код
				$x = $this->getCode($chars, $code_chars);
				// проверяем на совпадение в том числе и с сепаратором
				while (in_array($x, $ar_key) || strpos($x, $separator) !== false){
					$x = $this->getCode($chars, $code_chars);
					echo $x . '<hr />';
				}
				// добавляем в массив
				$ar_key[$n] = $x;
				$n = $n + 1;
			}
			$key = implode($separator, $ar_key);
			return base64_encode($key);
		}
		
		// функция генерации кода для символа
		private function getCode($chars, $code_chars){
			$n = 0;
			$x = '';
			while($n < $code_chars){
				$x = $x . substr($chars, rand(0, strlen($chars)-1), 1);
				$n = $n + 1;
			}
			return $x;
		}
		
		public function encode($data, $key){
			// строка символов
			$chars = $this->chars;
			// разделитель
			$separator = $this->separator;
			// получаем массив ключа
			$key = base64_decode($key);
			$ar_key = explode($separator, $key);
			// массив символов
			$ar_chars = str_split($chars);
			// массив ключа для шифровки
			$ar_key_sum = array();
			//собираем массив
			foreach ($ar_chars as $key=>$value){
				$ar_key_sum[$value] = $ar_key[$key];
			}
			// разбиваем строку на символы
			$ar_data_chars = str_split($data);
			// шифрованный массив
			$ar_code = array();
			foreach($ar_data_chars as $char){
				$ar_code[] = $ar_key_sum[$char];
			}
			// собираем в строку
			$code = implode($separator, $ar_code);
			// кодируем и выводим
			return base64_encode($code);
		}
		
		public function decode($data, $key){
			// строка символов
			$chars = $this->chars;
			// разделитель
			$separator = $this->separator;
			// получаем массив ключа
			$key = base64_decode($key);
			$ar_key = explode($separator, $key);
			// массив символов
			$ar_chars = str_split($chars);
			// получаем массив зашифрованной строки
			$data = base64_decode($data);
			$ar_data = explode($separator, $data);
			// собираем масив для расшифровки
			$decode_key = array();
			foreach($ar_key as $k => $v){
				$decode_key[$v] = $ar_chars[$k];
			}
			// собираем декодированную строку
			$data = '';
			foreach($ar_data as $value){
				$data = $data . $decode_key[$value];
			}
			return $data;
		}
		
	}
